#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h" /* 画像クラス */
#include"BMPIO.h" /* BMP画像の入出力関数 stdlib.hが必要 */

/* BMP画像を読み込んで平均化フィルタを適用しBMP画像として保存する 
コンパイル: g++ -o AverageFilter AverageFilter.cxx -lm
実行： ./AverageFilter 入力BMP 出力BMP 平均化する局所Windowの半径(int)
引数３
*/
int main(int argc,char *argv[]){
  
  
  /* 画像クラスImageを用いて入力画像のカラー用にR,G,Bを宣言する */
  
  

  /* 画像サイズ */
  int sx,sy;

  
  /* BMPIOクラスを宣言しnewする */
  
  /* BMPIOクラスのreadBMPSize()を使って、argv[1]で与えられたファイル名でsx,syに画像サイズを入れる */
  
  
  /* sx,syでR,G,Bのメモリを確保する(new する) */
  

  /* BMPIOクラスのreadBMP()を使ってargv[1]で与えられるファイル名の画像をR,G,Bに読み込む */

  
  /* 出力画像用にImageクラスをoutR,outG,outBとして宣言しsx,syのサイズでメモリを確保する */

   
  /* 平均化する局所Windowの半径を変数radiへセットする */
  int radi = atoi(argv[3]);
  
  
  /* 平均化ここから */  
  int i,j;
  /* 各画素をたどるループ */  
  for(i=0;i<sy;i++)
    for(j=0;j<sx;j++){
      /* R,G,B値を足し合わせるための変数を用意し、ゼロを代入する */
      

       /* 局所Window内の画素数Num、平均化の割り算で使う */
      double Num = 0.0;//端があるので一定(2radi+1)^2ではない
  

      int l,m;
       /* 局所Window内をたどるループ */  
      for(l=-radi;l<=radi;l++)
	for(m=-radi;m<=radi;m++){
	  /* 画素の座標[i+l][j+m]のR,G,B値を足し合わせる(重み１の畳み込み) */
	  /* 注意点：画像の端では足さない、つまり(i+l)>=0,(i+l)<sy,(j+m)>=0,(j+m)<sxの条件のときだけ足し合わせる */
	  
	  Num++;
	}
       /* エラーチェック：理論的にはありえないが、重みの総和がゼロのときにゼロの割り算を防ぐ */
      if(Num<=0.0)Num=1.0;
      /* 出力のoutR,outG,outBへ足し合わせた値を局所Window内の画素数Numで割って代入する */
      
      
    }
  

  /* 平均化ここまで */


  /* BMPIOクラスのsaveBMP()を使ってargv[2]で与えられるファイル名にoutR,outG,outBの画像を保存する */
  

  
  /* BMPIOクラスのメモリを開放する(deleteする) */
  

  /* R,G,Bのメモリを開放する(deleteする) */
  
  
  /* outR,outG,outBのメモリを開放する(deleteする) */
  
  

  return 0;
}
