#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h" /* 画像クラス */
#include"BMPIO.h" /* BMP画像の入出力関数 stdlib.hが必要 */

/* BMP画像を読み込んでエッジ強調を正規化Gaussianフィルタを用いて適用しBMP画像として保存する 
コンパイル: g++ -o EdgeEnhanceFilter EdgeEnhanceFilter.cxx -lm
実行： ./EdgeEnhanceFilter 入力BMP 出力BMP 平均化する局所Windowの半径(int) ガウス関数の標準偏差sigmaパラメータ(double) エッジ強調の度合い(double)
引数5
*/

void GaussianFilter(Image *R,Image *G,Image *B,Image *outR,Image *outG,Image *outB,int sx,int sy,int radi,double sigma){
  /* Gaussianフィルタの演習で作成した関数*/
}


int main(int argc,char *argv[]){
  
  
  /* 画像クラスImageを用いて入力画像のカラー用にR,G,Bを宣言する */
  Image *R = NULL;
  Image *G = NULL;
  Image *B = NULL;
  
  /* 画像サイズ */
  int sx,sy;
  
  /* BMPIOクラスを宣言しnewする */
  BMPIO *mybmp = new BMPIO();

  /* BMPIOクラスのreadBMPSize()を使って、argv[1]で与えられたファイル名でsx,syに画像サイズを入れる */
  if(mybmp->readBMPSize(&sx,&sy,argv[1])){

    /* sx,syでR,G,Bのメモリを確保する(new する) */
    R = new Image(sx,sy);
    G = new Image(sx,sy);
    B = new Image(sx,sy);

    /* BMPIOクラスのreadBMP()を使ってargv[1]で与えられるファイル名の画像をR,G,Bに読み込む */
    mybmp->readBMP(R,G,B,argv[1]);
    
  }else{
    delete mybmp;
    printf("Unsupported BMP format !\n");
    return 1;
  }

  /* 出力画像用にImageクラスをoutR,outG,outBとして宣言しsx,syのサイズでメモリを確保する */
  Image *outR = new Image(sx,sy);
  Image *outG = new Image(sx,sy);
  Image *outB = new Image(sx,sy);
   
  /* Gaussianフィルタを適用した画像(平滑化画像)用にImageクラスをsmoothR,smoothG,smoothBとして宣言しsx,syのサイズでメモリを確保する */
  Image *smoothR = new Image(sx,sy);
  Image *smoothG = new Image(sx,sy);
  Image *smoothB = new Image(sx,sy);
   
  


  /* 平均化する局所Windowの半径を変数radiへセットする */
  int radi = atoi(argv[3]);
  
  /* ガウス関数の標準偏差sigmaパラメータをsigmaへセットする */
  double sigma = atof(argv[4]);
  
  /* エッジ強調の度合いパラメータをvalkへセットする */
  double valk = atof(argv[5]);
  
  /* Gaussianフィルタでぼかす：平滑化画像の作成 */
  GaussianFilter(R,G,B,smoothR,smoothG,smoothB,sx,sy,radi,sigma);
  
  
 

  /* エッジ強調フィルタここから */  
  int i,j;
 
  /* 各画素をたどるループ */  
  for(i=0;i<sy;i++)
    for(j=0;j<sx;j++){
      /* ここでoutR,outG,outBへ　エッジ強調画像=元画像+valk*(元画像-平滑化画像)を計算. */
      
    }
  
  
  
  
  
  /* BMPIOクラスのsaveBMP()を使ってargv[2]で与えられるファイル名にoutR,outG,outBの画像を保存する */
  mybmp->saveBMP(outR,outG,outB,argv[2]);
  
  
  /* BMPIOクラスのメモリを開放する(deleteする) */
  delete mybmp;

  /* R,G,Bのメモリを開放する(deleteする) */
  delete R;
  delete G;
  delete B;
  
  /* outR,outG,outBのメモリを開放する(deleteする) */
  delete outR;
  delete outG;
  delete outB;
  
  /* smoothR,smoothG,smoothBのメモリを開放する(deleteする) */
  delete smoothR;
  delete smoothG;
  delete smoothB;
  
  return 0;
}
